/********************** use.cpp *********************/

#include "graph.h"

void printPath(long * lp, long cp){
    if(lp[cp] != MaxValue)
        printPath(lp, lp[cp]);
    cout << cp + 1 << ' ';
}

int main(int argc , char ** argv)
{
    Graph g;
	char *file;
	cout<<"reading matrix file..."<<endl;
//	int m=g.Init("data.txt");
//	int m=g.Init("HFY.ensembl.cyto.matrix");
	//int m=g.Init("gse9055_entrez_id_hprd_ppi.dist_matrix.txt");
      long m=g.Init(argv[1]);
	//long m=g.Init("test.dist_matrix.txt");
      cout<<"total nodes:"<<m<<endl;
 
    long spoint;
    float * length;
    long * last_point;
	ofstream out;
	out.open(argv[2]);
      //out.open("test.out");
for(spoint=1;spoint<=m;spoint++)
{
	cout<<spoint<<endl;
    long n = g.Dijkstra(spoint - 1, length, last_point);
    for(long i = 0; i < n; i ++)
	{
       // cout <<spoint<<"->"<< i + 1 << "; Lenght:" << length[i] << "; Path:";
       // printPath(last_point, i);
		//cout<<endl;
		//cout << length[i]<<"\t";
		out<<length[i]<<"\t";
    }
	out<<endl;
}
/**/
//   g.printGraph();
    /**
    edge * edges_prim;
    edge * edges_kruskal;
    int i;
    int n = g.Prim(edges_prim);
    cout << "Prim Mini edges : " << endl;
    for(i = 0; i < n; i ++)
        cout << '(' << edges_prim[i].fromvex << ',' << edges_prim[i].endvex << ')' <<
            " Weight : " << edges_prim[i].weight << endl;
    
    n = g.Kruskal(edges_kruskal);
    cout << "Kruskal Mini edges : " << endl;
    for(i = 0; i < n; i ++)
        cout << '(' << edges_kruskal[i].fromvex << ',' << edges_kruskal[i].endvex << ')' <<
            " Weight : " << edges_kruskal[i].weight << endl;
    /**/
	/**/

    return 0;
}  
