/******************************************************************************/    
/*
	Edge.h
	Written by Matthew Maxel
	Created March 4, 2002
*/
/******************************************************************************/    
#ifndef Edge_h
#define Edge_h
/******************************************************************************/    
#include <iostream>
#include <string>
#include <sstream>
class Edge
{
	friend std::istream &operator>>(std::istream&, Edge&);
	friend std::ostream &operator<<(std::ostream&, const Edge &e);
public:
	int p1;
	int p2;
	double cost;

	Edge(void);			
	Edge(int p1, int p2, double cost);
	Edge(const Edge& e); // Copy constructor
	~Edge(void);
	int operator==(Edge& e);
	//Path operator+(const Edge& e1, const Edge& e2);
};
/******************************************************************************/    
#endif
/***************************************************************************/
