/****************************************************************************/
#include <iostream>
#include<fstream>
#include <stdio.h>
#include<stdlib.h>
#include<string.h>
#include "Graph.h"
#include "system.h"
#include "xmenus.h"
#include "Time.h"
#include "const.h"
#include "ret.h"

/****************************************************************************/
void get_return(void);
//void printUsage(void);
void processScriptFile(char *name);
System Sys;
int memory_used=0;
/****************************************************************************/
//using std::cout;
//using std::cin;
using namespace std;
/****************************************************************************/
int main(int argc, char* argv[])
{
	Graph G;
	int i,n,num=100,numActualPaths,a;
	char file[1024],msg[1024],nums[128];
	Path *paths;	
	int fileMode=FALSE,timeMode=FALSE,showPaths=FALSE;
	Time t1,t2,td;
        int start1,end1;
        ofstream o1;
        ifstream f1;
        int source,sink;

	//if (argc<3) {
		//printUsage();
		//exit(-1);
	//}

	//num=10;
        strcpy(file,argv[1]);
        fileMode=TRUE;
        showPaths=TRUE;
	/*for (i=1;i<argc;i++) {
		if (argv[i][0]=='-') {
			switch(argv[i][1]) {
			case 'a':
			case 'A':
				a=atoi(argv[i+1]);
				i++;
				break;
			case 't':
			case 'T':
				timeMode=TRUE;
				break;
			case 'f':
			case 'F':
				strcpy(file,argv[i+1]);
				fileMode=TRUE;
				i++;
				break;
			case 's':
			case 'S':
				strcpy(file,argv[i+1]);
				i++;
				break;
			case 'n':
			case 'N':
				num=atof(argv[i+1]);
				i++;
				break;
			case 'p':
			case 'P':
				showPaths=TRUE;
				break;
			}
		}
		//else printUsage();
	}*/
       //cout<<"liyuanfeng"<<endl;
//////////
//ofstream examplefile; 

//examplefile.open(argv[2], ios::out | ios::app | ios::binary); 

//////////
        f1.open(argv[3]);
        f1>>num;
        f1.close();
        f1.clear();
   istringstream ts1,ts2;
   ts1.str(argv[4]);
   ts1>>source;
   ts2.str(argv[5]);
   ts2>>sink;
	if (fileMode) {	
         //fp >> s >> startNode;
	//fp >> s >> endNode;
                
		n=G.input(file);
		if (n==OK) {///////////////1
                        o1.open(argv[2],ios::app|ios::out);
                        //f2.open(argv[4]);
                       // while((f2>>source)!=NULL)
                      //  {/////////////////2
                        //  f3.open(argv[5]);
                       // while((f3>>sink)!=NULL)
                       // {//////////////3
                         G.setStartNode(source);
                        G.setEndNode(sink);
			paths=new Path[num];
			//cout << "Computing " << num << " paths\n";
                        a=3;
			switch(a) {
			case 2:
				//cout << "Using Yen ksp algorithm\n";
				t1.setCurrent();
				numActualPaths=G.computeYenKSP(num,paths);
				t2.setCurrent();
				td=t2-t1;
				break;
			case 3:
				//cout << "Using new optimized ksp algorithm\n";
				//t1.setCurrent();
				numActualPaths=G.computeNewKSP(num,paths);
				//t2.setCurrent();
				//td=t2-t1;
				break;
			case 1:
			default:
				//cout << "Using new ksp algorithm\n";
				//t1.setCurrent();
				numActualPaths=G.computeKSP(num,paths);
				//t2.setCurrent();
				//td=t2-t1;
				break;
			}
                       
                       // cout<<"liyuanfeng"<<endl;
			if (showPaths) {
                                   //start1= G.getStartNode();
                                     //   end1=G.getEndNode();
                                       // o1<<start1<<" "<<end1<<endl;

				for (i=0;i<numActualPaths;i++) {
					sprintf(nums,"%d",i);
					G.formatPath(nums,paths[i],msg);
                                          // examplefile<<msg<<"\n";
					//cout << msg << "\n";
                                        o1<<msg<<"\n";
                                        o1<<"-1"<<" ";
				}
			}

			// If timing print the time
			//if (timeMode) 
			//	cout << "DeltaTime:" << td << "\n";

			// Free the paths
			delete [] paths;
                                 //o1<<source<<endl;
                      //}//////////3

                                     // f3.close();
                                    //  f3.clear();
                    // }//////////////2
                    o1.close();
                    o1.clear();
                  //  f2.close();
                   // f2.clear();
			// Give user time to see result
			//if (showPaths || timeMode) get_return();
		}/////////1
	}


	return 0;
}
/****************************************************************************/
void processScriptFile(char *name)
{

}
/****************************************************************************/
/*void printUsage(void)
{
	cout << "Usage:ksp -f graphfile [-n NumberOfPaths] [-a Algorithm] [-t] [-p]\n";
	cout << " -f graphFile is the name of the file to load\n";
	cout << " -n NumberOfPaths defaults to 10\n";
	cout << " -a algorithm 1=New KSP(default), 2=Yen's KSP, 2=New Optimized KSP\n";
	cout << " -t Print time information\n";
	cout << " -p Print the paths\n";
	get_return();
	exit(-1);
}*/
/****************************************************************************/
void get_return(void)
{
	char s[256];
	//cout << "Press return to continue...";
	cin.getline(s,128);
}
/****************************************************************************/
void put_error(char *msg)
{
	cout << msg << "\n";
	get_return();
}
/****************************************************************************/
void putError(char *msg)
{
	cout << msg << "\n";
	get_return();
}
/****************************************************************************/
void show_msg(char *msg)
{
	cout << msg << "\n";
}
/****************************************************************************/
void show_side_msg(char *msg)
{
	cout << msg << "\n";
}
/****************************************************************************/
// Stubs for graphic routines that we are not using
/****************************************************************************/
int drw_open_drw(char *name)
{
	return(OK);
}
/******************************************************************************/
int drw_open_lab(double lat, double lon, long color, char *text,
    long size, char *font, int just)
{
	return(OK);
}
/******************************************************************************/
int drw_open_seg(int color, int type, int subtype)
{
	return(OK);
}
/******************************************************************************/
int drw_open_spt(double x, double y)
{
	return(OK);
}
/******************************************************************************/
int drw_del_name(char *name)
{
	return(OK);
}
/******************************************************************************/
void pix_to_xyz(int px, int py,double *x,double *y)
{
}
/***************************************************************************/
void xyz_to_pix(double x,double y, int *px, int *py)
{
}
/***************************************************************************/
void xyz_to_geo(double x,double y,double *lat,double *lon)
{
}
/***************************************************************************/
void set_menu(int n, char *msg, int m)
{
}
/***************************************************************************/
