/*********************************************************/
/* 
    types.h 
*/
/*********************************************************/
#ifndef _TYPES
#define _TYPES 1
/*********************************************************/
typedef unsigned char byte;
typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned int uint;

struct TIME {
    unsigned long sec;
    unsigned long usec;
};

struct CHAIN {
	void *first;
	void *last;
};

struct LLIST {
	CHAIN curr;
	CHAIN buff;
	CHAIN undo;
};

struct pix_pos {
    int x;
	int y;
};

struct geo_pos {    
    double lat;      /* DEG */    
    double lon;      /* DEG */    
    double alt;      /* FT */    
};    
    
struct xyz_pos {    
    double x;        /* FT */    
    double y;           
    double z;    
};    
    
struct ecef_pos {    
    double x;        /* FT */    
    double y;    
    double z;    
};    
 
/*********************************************************/
#endif
/*********************************************************/
