/******************************************************************************/
/* 
	xdrw.h
*/
/******************************************************************************/
#ifndef _XDRW
#define _XDRW 1
/******************************************************************************/
/*#include <Windows.h>
#include <stdio.h>
#include "types.h"
#include "xpos.h"*/
/******************************************************************************/
/* Drawing queries */
/*#define NDRW             21
#define NPTS             23
#define NLAB             24
#define LAST_POINT       28
#define LAST_LABEL       29
#define CLOSEST_POINT    30
#define CLOSEST_LABEL    31
#define NPICKED          32 */
/***************************************************************************/
/*#define SEGTYPE      0
#define COLOR        1
#define LINETYPE     2
#define DIMENSION    3
#define FILLTYPE     4
#define MARKERTYPE   8
#define FILETYPE    10
#define COORDINATES 11
#define FORMAT      12
#define FONTSIZE    13
#define FONT        14
#define PICKED      15
#define INVISIBLE   16*/
/***************************************************************************/
/*#define SOLID        0
#define DASH1        1
#define DOT1         2*/
/***************************************************************************/
//#define LINE         0
//#define POLYGON      1
//#define MARKER       2
/***************************************************************************/
//#define DOT          0
//#define STAR         1
//#define PLUS         2
/***************************************************************************/
/*struct SEG_RECORD {
	int npts; 
	int alloc;
	geo_pos *pt;
	int color;
	struct {
		unsigned int type:2;
    	unsigned int subtype:8;
	} b;
	void *next;
	void *prev;
};

struct LAB_RECORD {
    geo_pos pt;
	int color;
	struct {
		unsigned int xjust:2;
		unsigned int yjust:2;
		unsigned int bold:1;
		unsigned int italic:1;
		unsigned int underline:1;
		unsigned int strikeout:1;
	} b;
	long size;
	char font[48];
    char text[1024];
	void *next;
	void *prev;
};

struct DRW_RECORD {
    char name[64];
    struct {
        unsigned int ver2:1;
        unsigned int ver1:1;
        unsigned int spare:1;
        unsigned int file:3;
        unsigned int format:1;
        unsigned int proj:1;
		unsigned int selected:1;
		unsigned int new_selected:1;
		unsigned int invisible:1;
		unsigned int locked:1;
		unsigned int needs_drawing:1;
		unsigned int choosen:1;
    } b;
	short max_x;
	short min_x;
	short max_y;
	short min_y;

	CHAIN labc;
	CHAIN segc;

	void *next;
	void *prev;
};*/
/******************************************************************************/
/*void drw_init(void);
DRW_RECORD *drw_new(char *name);
DRW_RECORD *drw_add(char *name);
DRW_RECORD *drw_add_to_chain(CHAIN *chain, char *name);
SEG_RECORD *seg_new(void);
LAB_RECORD *lab_new(void);
SEG_RECORD *drw_seg_add(DRW_RECORD *drw);
LAB_RECORD *drw_lab_add(DRW_RECORD *drw);
DRW_RECORD *drw_find_name(char *name);
int drw_del(CHAIN *chain, DRW_RECORD *drw);
int drw_lab_del_all(DRW_RECORD *drw);
int drw_seg_del_all(DRW_RECORD *drw);
int drw_close(void);
DRW_RECORD *drw_find_pix(pix_pos p);
int drw_write(char *path);
int drw_copy(DRW_RECORD *src, DRW_RECORD *dst);
int drw_remove(CHAIN *chain, DRW_RECORD *drw);
int drw_move(int dx,int dy);
void set_max_min_drw(DRW_RECORD *drw, int x, int y);
void draw_all_drw(HDC hdc);
void draw_needed_drw(void);
void draw_drw(HDC hdc, DRW_RECORD *drw);
void draw_last_drw(void);
int drw_seg_xpt_add(SEG_RECORD *seg, double x, double y, double z);
int drw_seg_ppt_add(SEG_RECORD *seg, int x, int y);
int drw_seg_pt_add(SEG_RECORD *seg, double lat, double lon, double alt);
int input_drw(char *path);
int output_drw(DRW_RECORD *drw, char *dir, int warning);
int check_for_drw(int x, int y);
int copy_selected_drw_to_undo(void);
void translate_selected_drw(double dx, double dy);
void scale_selected_drw(double dx, double dy, double fx, double fy);
void rotate_selected_drw(double dx, double dy, double a);
void translate_drw(DRW_RECORD *drw, double dx, double dy);
void scale_drw(DRW_RECORD *drw, double dx, double dy, double fx, double fy);
void rotate_drw_z(DRW_RECORD *drw, double dx, double dy, double a);
void find_max_min_drw(DRW_RECORD *drw, double *latmin, double *lonmin,
    double *latmax, double *lonmax);
int look_for_selected_drw(int x, int y);
void drw_cut(void);
void drw_paste(void);
void draw_changed_selected_drw(HDC hdc, int mode, double dx, double dy, double fx, double fy);
void draw_changed_drw(HDC hdc, DRW_RECORD *drw, int mode, double dx, double dy, double fx, double fy);
void translate_selected_drw(double dx, double dy);
void scale_selected_seg(double dx, double dy, double fx, double fy);
void rotate_selected_seg(double dx, double dy, double a);
int drw_del_selected(void);
int copy_selected_drw_to_paste(void);
void drw_undo(void);
int find_selected_drw_center(double *xr, double *yr);
int drw_group(void);
int drw_ungroup(void);
int unselect_all_drw(void);
int select_all_drw(void);
int check_for_multiple_drw(int xp1, int yp1, int xp2, int yp2);
int drw_set_selected_font(LOGFONT lf, int color, int xjust, int yjust);
int drw_get_selected_font(LOGFONT *lf, int *color, int *xjust, int *yjust);
LAB_RECORD *drw_get_selected_lab(void);
int drw_set_selected_attributes(int *color, int *type, int *subtype);
int drw_get_selected_attributes(int *color, int *type, int *subtype);
int drw_del_last_pt(void);
int query_drw_position(int n, double *lat, double *lon);
int output_selected_drw(void);
int write_all_drw(FILE *fp);
int read_all_drw(FILE *fp);
int drw_lock_current(int lock);
int drw_lock(DRW_RECORD *drw, int lock);
int adjust_drw(double lon);
void draw_one_drw(DRW_RECORD *drw);
int drw_move_to_current(DRW_RECORD *drw);
int check_drw_state(void);
int check_drw_undo_state(void);
int check_drw_buff_state(void);*/
/******************************************************************************/
// Old interface
/*int drw_open_drw(char *name);
int drw_open_seg(int color, int type, int subtype);
int drw_open_gpt(double lat, double lon);
int drw_open_spt(double x, double y);
int drw_open_spt(xyz_pos p);
int drw_open_lab(double lat, double lon, long color, char *text,
    long size, char *font, int just);
int drw_open_slab(double x, double y, long color, char *text,
    long size, char *font, int just);
int drw_del_name(char *name);*/
/******************************************************************************/
//int get_drw(char *msg, int one);
//int drw_menu(HWND hdlg, unsigned wmsg, WORD wparam, LONG lparam);
//void drw_edit_lock(void);
//void drw_edit_visibility(void);
//void rename_drw(void);
//void zoom_to_choosen_drw(void);
//void drw_clear_choosen(void);
/******************************************************************************/
// Yet another interface
//int drw_seg_open(DRW_RECORD *drw, int color, int type, int subtype);
//int drw_gpt_open(DRW_RECORD *drw, double lat, double lon, double alt);
//int drw_spt_open(DRW_RECORD *drw, double x, double y, double z);
/******************************************************************************/
//int drw_set_selected_attr(int types, int attr, int val);
//int drw_get_selected_attr(int type, int attr, int *val);
//int find_unique_name(char *name);
/******************************************************************************/
//int get_marker(SEG_RECORD *seg);
//BOOL FAR PASCAL marker_menu(HWND hDlg,unsigned wMsg, DWORD wParam, LONG lParam);
/******************************************************************************/
#endif
/******************************************************************************/
