/***************************************************************************/
/*
    xmenus.h
	This file contains prototype for simple user io functions and a structure
	for exchanging lists
	Created 5/8/98
*/
/***************************************************************************/
// Data for getting list items
struct LIST_RECORD {
    char name[128];
    union {
        int word;
        struct {
    	    unsigned int selected:1;
            unsigned int grayed:1;
        } bit;
     } u;
};
extern LIST_RECORD io_list[2048];
extern int io_nlist;
/***************************************************************************/
void put_info(char *msg);
void put_error(char *msg);
void putError(char *msg);
void processMenuCommand(int, int, long);
void shutdown_algo(void);
void init_dialog(void);
int get_view(void);
int get_string(char *, char *, char *);
void about(void);
int get_pos(char *, double *, double *);
int get_yesno(char *);
int get_mfile(char *);
int get_double(char *, double, double *);
int get_int(char *, int, int *);
int get_name(char *, char *, char *);
void show_msg(char *msg);
void show_side_msg(char *msg);
void set_menu(int item, char *text, int flags);
void insert_menu(int item0, int new_item, char *name);
int get_rightleft(char *msg, char *option1, char *option2);
int get_list(char *msg);
void set_drw_exists(int n);
void set_undo_exists(int n);
void set_buff_exists(int n);
void set_pts_exist(int n);
/***************************************************************************/
