#!/usr/bin/perl -w
use strict;

open( in1, "<$ARGV[0]" );
my $max_cluster = 0;
while( my $line1 = <in1> ) {
	my $line2 = <in1>;
	my $line3 = <in1>;
	
	chomp( $line1 );
	my ( $t1, $cluster1, $cluster2 ) = split( /\s/, $line1 );
	chomp( $line2 );
	my $interdist = substr( $line2, 13 );
	chomp( $line3 );
	my $intradist = substr( $line3, 24 );
	
	my @genes = split( /:/, "$cluster1:$cluster2" );
	
	if( $#genes + 1 >= 1 && $#genes + 1 > $max_cluster ) {
		$max_cluster = $#genes + 1;
		print join( "\t", $#genes + 1, $interdist, $intradist, "$cluster1:$cluster2" );
		print "\n";
	}
}
close( in1 );
