#!/bin/bash
mkdir ./bin
mkdir ./data
mkdir ./result

cd shortest_path
g++ main.cpp graph.cpp -o shortest_path
mv shortest_path ../bin/
cd ..

cd src
g++ BranchingStructure.cpp compare.cpp Edge.cpp FibonacciHeap.cpp Graph.cpp GraphDrawings.cpp GraphGenerate.cpp GraphKSP.cpp GraphNewKSP.cpp graphReplacement.cpp GraphSP.cpp graphYen.cpp ksp.cpp LinkList.cpp Path.cpp primatives.cpp sutil.cpp Time.cpp System.cpp -o KSP
mv KSP ../bin/

g++ transid.cpp  -o transid
mv transid ../bin/

g++ manyKSP.cpp  -o manyKSP
mv manyKSP ../bin/

g++ transid1.cpp  -o transid1
mv transid1 ../bin/

g++ transid2.cpp  -o transid2
mv transid2 ../bin/

g++ count.cpp  -o count
mv count ../bin/

g++ extend_step-KSP.cpp  -o extend_step-KSP
mv extend_step-KSP ../bin/
cd ..

