/*************** graph.h *********************/
#ifndef _Graph_Vaan
#define  _Graph_Vaan
#include <iostream>
#include <fstream>
using namespace std;

#define MaxValue 10000

/*class edge{
public:
    int fromvex;
    int weight;
    float endvex;
    edge & operator = (edge& e);
};*/
// DijItem & Queue is exist for Dijktra
class DijItem{
public:
    long iNode;
    long iPrev;
    float iDist;
    DijItem * next;
};

class Queue{
public:
    Queue(){
        this->root = NULL;
        this->length = 0;
    }
    ~Queue(){
        DijItem * temp;
        while(this ->root){
            temp = this ->root;
            this ->root = this ->root ->next;
            delete temp;
        }
    }
    void enQueue(long, float, long);
    void dequeue(long&, float&, long&);
    long getLength(){
        return this->length;
    }
private:
    DijItem * root;
    long length;
};
// Graph
class Graph{
public:
	long Init(char* matrixfile);
    Graph(){        
    }
    ~Graph(){
        delete [] adjmatrix;
    }
    // int Prim(edge *&);
    // int Kruskal(edge *&);
    long Dijkstra(long, float *&, long *&);

    void printGraph();
private:
    long MaxVertextNum;
    float* adjmatrix;
};

#endif
