/******************************************************************************/
#ifndef BranchingStructureNode_h
#define BranchingStructureNode_h 1
/******************************************************************************/
#include "types.h"
#include "Path.h"
#include <list>

class BranchingStructureNode
{
public:
	BranchingStructureNode *up;		// Points to Parent
	std::list < BranchingStructureNode * > children;
	Path *prefixPath;		// Path that this node represents
	int node;				// Node in the graph that this node represents
	int order;				// Used to order the paths
	int num;				// ??? Tmp
};
typedef BranchingStructureNode BRNODE;
typedef std::list< BranchingStructureNode * > BRLIST;
typedef BranchingStructureNode * PBRNODE;
/******************************************************************************/
#endif
/******************************************************************************/
