/***************************************************************************/
/*
	data_param.h
	Written by Matthew Maxel
	Created Feb 2, 2002

	The file defines a structure which contains all of the data parameters
*/
/******************************************************************************/
#ifndef DataParam_h
#define DataParam_h
/***************************************************************************/
struct DataParameters {
	int npts;							// Number of points
	int nedges;							// Number of edges in the graph
	int length;							// Length of grid graph
	unsigned int negativeEdgeCosts:1;	// TRUE - negatvie edge cost
	unsigned int directed:1;			// TRUE - directed graph
	unsigned int grid:1;
};
/***************************************************************************/
struct EdgeList {
	int start;
	int n;
};
/***************************************************************************/
#endif
/***************************************************************************/
