/******************************************************************************/
/*
	Edge.cpp
	Written by Matthew Maxel
	Created March 4, 2002
*/
/****************************************************************************/
// Edge is a list of vertecies or edge and an associated cost
/****************************************************************************/
#include "edge.h"
#include <iostream>
#include <string>
#include <sstream>
#include "const.h"
/****************************************************************************/
Edge::Edge(void) 
{
	p1=0;
	p2=0;
	cost=INF;
}
/******************************************************************************/
Edge::Edge(int p1In, int p2In, double costIn)
{
	p1=p1In;
	p2=p2In;
	cost=costIn;
}
/******************************************************************************/
Edge::Edge(const Edge& p)
{
	p1=p.p1;
	p2=p.p2;
	cost=p.cost;
}
/******************************************************************************/
Edge::~Edge(void)
{
}
/******************************************************************************/
/*
Edge Edge::operator+(const Edge& p)
{
	int i,n=nList+p.nList;
	Edge path(n);
	for (i=0;i<nList;i++) path.list[i]=list[i];
	for (i=0;i<p.nList;i++) path.list[i+nList]=p.list[i];
	path.cost=cost+p.cost;
	path.nList=n;
	return path;
}
*/
/******************************************************************************/
int Edge::operator==(Edge& e)
{
	if (p1==e.p1 && p2==e.p2 && cost==e.cost) return(TRUE);
	else return(FALSE);
}
/***************************************************************************/
std::ostream &operator<<(std::ostream &output, const Edge &e)
{
	output << "Edge " << e.p1 << " " << e.p2 << " " << e.cost;
	return(output);
}
/***************************************************************************/
std::istream &operator>>(std::istream &input, Edge &e)
{
	char s[128];
	input >> s >> e.p1 >> e.p2 >> e.cost;
	return(input);
}
/***************************************************************************/
