/***************************************************************************/
/*
	LinkList.h
	Written by Matthew Maxel
	Created Dec 10, 2002
	Modified May 10, 2002
*/
/******************************************************************************/
#include "LinkListItem.h"
/******************************************************************************/    
#ifndef LinkList_h
#define LinkList_h 1
/***************************************************************************/
class LinkList {
	LinkListItem *first;
	LinkListItem *last;
	int nLinkListItems;
	int myLLChunk;
public:
	LinkList(void);
	~LinkList(void);
	void appendKey(void *key);
	void push_back(void *key);	// To keep compatibility
	void prependKey(void *key);
	void deleteItem(LinkListItem *item);
	LinkListItem *getFirst(void);
	LinkListItem *getLast(void);
	int getNumItems(void);
	LinkListItem *newItem(void);
};
/***************************************************************************/
#endif
/***************************************************************************/
