/***************************************************************************/
/* NodeLabels.h */
/***************************************************************************/
#ifndef	NodeLabels_h
#define NodeLabels_h
/***************************************************************************/
class NodeLabels {
public:
	int num;				// Node number

	double cost;			// Cost of getting to this node from startNode
	int predEdge;			// Predecessor edge getting to this node
							// (-1) = no predecessor edge
							// (-2) = start node
	double reverseCost;		// Cost to terminating node
	int reversePredEdge;	// Best path to terminating node

	int scanned;			// Temporary flag indicating nodes was scanned
	int valid;				// This point is included in graph
	int path;				// Order of node on shortest path
							// -1 if not on shortest path
	int block;				// Block that the nodes is in
	int minblock;			// Minimum block of node of path of this node to y

	//void *node;				// Temporary pointer to shortest path tree node
	void *fnode;			// Temporary pointer to heap node
};
#endif
/***************************************************************************/
