/***************************************************************************/
/* const.h */
/***************************************************************************/
#include <float.h>
const double RE=3438.206;
const double PI=3.141592653589;
const double RAD_TO_DEG=(180.0/PI);
const double DEG_TO_RAD=(PI/180.0);
const double SQRT2=1.414213562373;
/***************************************************************************/
const int FOREVER=1;
const int NEVER=0;
#ifndef TRUE
	const int TRUE=1;
	const int FALSE=0;
#endif
const int ON=1;
const int OFF=0;
/***************************************************************************/
/* Distance constant definitions */
const double  FT_TO_M=0.3048;
const double  M_TO_FT=3.280839895;
const double  NM_TO_M=1852.0;
const double  M_TO_NM=0.0005399568035;
const double  KM_TO_NM=0.5399568035;
const double  NM_TO_KM=1.8520F;
const double  NM_TO_FT=6076.1155;
const double  FT_TO_NM=0.0001645788333;
const double  MI_TO_NM=0.86897624;
const double  NM_TO_MI=1.15077939;
const double  DM_TO_NM=0.98747300;
const double  NM_TO_DM=1.01268592;
const double  YD_TO_M=0.9144;
const double  M_TO_YD=1.0936133;
/***************************************************************************/
const double  SEC_TO_HRS=1.0/3600.0;
const double  HRS_TO_SEC=3600.0;
const double  MIN_TO_SEC=60.0;
const double  SEC_TO_MIN=1.0/60.0;
const double  MIN_TO_HRS=1.0/60.0;
const double  HRS_TO_MIN=60.0;
const double  GRAV=0.0000146;
const double  KTS_TO_FPS=1.687809722222;
const double  FPS_TO_KTS=0.5924838486434;
const double  KTS_TO_MPS=0.5144444444444; 
const double  MPS_TO_KTS=1.943844492441;
const double  GFORCE=32.17;		// Ft/s*s
/***************************************************************************/
const int  MAXNPOLYPTS=5120;
/***************************************************************************/
const double INF=DBL_MAX;
const double NEGINF=(-DBL_MAX);
/***************************************************************************/
