/***************************************************************************/
/* ret.h */
/***************************************************************************/
#define REDO            3
#define OK2             2
#define CLOSE_ENOUGH    2
#define OK              1
#define REDRAW        0x1
#define RESIZE        0x2
#define NO_CHANGE       0
#define ZERO            0    /* General errors */
#define NO_SEG         -1    /* Display list errors */
#define NO_DRW         -2    /* Display list errors */
#define NO_SSG         -2
#define NO_PTS         -3
#define NO_LAB         -4
#define NOT_FOUND      -5    /* General */
#define NO_BSEG        -9    /* Display list buffer errors */
#define NO_BSSG       -10
#define NO_BPTS       -11
#define NO_BLAB       -12
#define TOO_LARGE     -20    /* General errors */
#define TOO_SMALL     -21    /* General errors */
#define TOO_MANY_PTS  -25
#define INVALID_CHAR  -26
#define BAD_SIGN      -27
#define ROW_ERROR     -30    /* Lookup tables */
#define COLUMN_ERROR  -32
#define OUT_OF_BOUNDS -33
#define LEVEL_ERROR   -34
#define NO_TABLE      -35
#define TABLE_ERROR   -36
#define TREE_ERROR	  -37
#define NO_SOLUTION   -38
#define NEGATIVE_CYCLE -40
#define NO_PATH       -41
#define INVALID_PATH  -42
#define DUPLICATE_PATH -43
#define NO_FPTS       -50	// Vehicle errors
#define NO_WPTS       -51
#define TURN_ERROR    -52
#define FILE_ERROR    -60    // File errors 
#define READ_ERROR    -61
#define WRITE_ERROR   -62
#define COM_ERROR     -65    /* Com errors */
#define MSG_ERROR     -66    /* Com msg errors */
#define TIMEOUT       -67
#define NO_TGTS       -75
#define NOT_DEFINED   -80    /* OS errors */
#define DRIVE_ERROR   -85
#define NO_MEMORY     -87
#define DB_ERROR      -88
#define NEXT_ITEM     -96    /* Control items */
#define PREV_ITEM     -97
#define ABORT         -98
#define END           -99
/***************************************************************************/
